#include "calibration.hpp"

using namespace cv;

Mat cameraMatrix(cv::Size(3, 3), CV_64F);
Mat distCoeffs(cv::Size(1, 5), CV_64F);
double focalLength;

// These values were automatically found using the calibration code in the
// 'calibrate' folder.
void initializeCalibration() {
	cameraMatrix.at<double>(0, 0) = 209.048;
	cameraMatrix.at<double>(0, 1) = 0;
	cameraMatrix.at<double>(0, 2) = 162.181;
	cameraMatrix.at<double>(1, 0) = 0;
	cameraMatrix.at<double>(1, 1) = 208.224;
	cameraMatrix.at<double>(1, 2) = 119.554;
	cameraMatrix.at<double>(2, 0) = 0;
	cameraMatrix.at<double>(2, 1) = 0;
	cameraMatrix.at<double>(2, 2) = 1;

	distCoeffs.at<double>(0, 0) = 0.288485;
	distCoeffs.at<double>(0, 1) = -0.754981;
	distCoeffs.at<double>(0, 2) = -0.000210233;
	distCoeffs.at<double>(0, 3) = 0.00313993;
	distCoeffs.at<double>(0, 4) = 0.476459;
	
	focalLength = 208.636;

}

void undistort(Mat in, Mat& out)
{
    undistort(in, out, cameraMatrix, distCoeffs);
}