#include "corner.hpp"
#include "mask.hpp"

using namespace cv;
using namespace std;

Mat drawCorners(Mat& m, vector<Point2f> corners)
{
    Mat drawImage;
    m.copyTo(drawImage);
    
    vector<Point2f>::iterator c;
    for (c = corners.begin(); c != corners.end(); ++c)
        circle(drawImage, *c, 2, Scalar(0, 0, 255), -1);

    return drawImage;
}


vector<Point2f> findCorners(Mat& im)
{  
    vector<Point2f> corners;
    
    Mat im8u, bwImage;

    // If the incoming image has a mask attached, remove it.
    if (im.type() == CV_16UC4)
        im8u = maskedTo8U(im);
    else
        im8u = im;
    
    cvtColor(im8u, bwImage, CV_BGR2GRAY);    
    
    // Let's be lazy and use OpenCV's corner extraction.
    goodFeaturesToTrack(bwImage, corners, 500, 0.01, 5);
    return corners;        
}