#include <iostream>
#include <opencv2/opencv.hpp>
#include <sstream>

#include "feature.hpp"
#include "stitchPan.hpp"

using namespace cv;
using namespace std;


int main(int argc, char** argv)
{
    initializeCalibration();

    vector<Mat> images;
    
    // Load in a set of images,  undistort them, and add them to a list.
    for (int i = 1; i < min(argc, argc); ++i)
    {
        Mat undistorted;
        undistort(addMask(imread(argv[i])), undistorted);
        images.push_back(undistorted);
    }
    
    Mat combined = stitchPanI(images);
    imwrite("panorama.png", combined);
    imshow("combined", combined);
    
    cout << "Done.  Press any key to exit." << endl;
    waitKey(-1);
}