#pragma once

#include <vector>

#include <opencv2/opencv.hpp>

class Feature;

struct Match {
    cv::Point2f loc1;
    cv::Point2f loc2;
    double bestMatch;
    double secondMatch;
    Match(cv::Point2f loc);
    bool operator<(const Match& m) const;
};

std::vector<Match> getMatches(std::vector<Feature>& f1,
                              std::vector<Feature>& f2);
void drawMatches(cv::Mat& im1, cv::Mat& im2, std::vector<Match> matches,
                 unsigned int n);