#pragma once

#include <opencv2/opencv.hpp>

#include <vector>

class Match;

struct RotID {
    RotID(size_t im1, size_t im2, double rot);
    friend bool operator==(const RotID& r1, const RotID& r2);
    size_t im1num, im2num;
    double im1rot;
    double im2rot;
};

bool operator==(const RotID& r1, const RotID& r2);

cv::Mat rotateImage(const cv::Mat& source, double angle);
cv::Point2f rotatePoint(cv::Point2f pt, cv::Point2f center, double rot);
double findBestRotation(std::vector<Match> matches, cv::Size size, cv::Mat& bestH);
double findBestRotationCached(size_t im1ID, size_t im2ID, double im1rot,
                              std::vector<Match> matches, cv::Size size,
                              cv::Mat& bestH);